package db

import "errors"

var (
	ErrNoneConnect = errors.New(`not connect to database`)
)

// DB error code
const (
	// ErrOK ok
	ErrOK = 0
	// ErrException exception 异常
	ErrException = 1
	// ErrExists exists 数据存在
	ErrExists = 2
	// ErrNotFound not found 未找到关键数据
	ErrNotFound = 3
	// ErrAuthorized authorized 未认证
	ErrAuthorized = 4
	// ErrNotConnect connect error 数据库内部连接错误
	ErrNotConnect = 5
	// data not found 数据未找到
	ErrDataNotFound = 6
	// expired 已过期
	ErrExpired = 7
	// insufficient balance 余额不足
	ErrInsufficientBalance = 8
	// Credit Limit 超额
	ErrCreditLimit = 9
)
